请选择 进入手机版 | 继续访问电脑版

[讨论] 【已解决】怎么把控制点拉回到曲面上。不要重新成体

[复制链接]
筑梦NARUTO 发表于 2017-2-25 16:18:57
11
DAKA_Ye 发表于 2017-2-25 12:18
可以把是投影效果的投影到曲线跟曲面的代码分别也发下吗?谢谢

曲线的
  1. #coding=utf-8
  2. import Rhino.Geometry as rg
  3. import Rhino as r
  4. import rhinoscriptsyntax as rs
  5. import scriptcontext as sc

  6. result,grips = r.Input.RhinoGet.GetGrips("选择要移动的控制点")
  7. curve = rs.GetObject("选择用于干扰的曲线",rs.filter.curve)
  8. dis = {}
  9. if (result == r.Commands.Result.Success and curve):
  10.     geo_curve = sc.doc.Objects.Find(curve).Geometry
  11.     t = 0
  12.     for i in grips:
  13.         oid = i.OwnerId
  14.         obj = sc.doc.Objects.Find(oid)
  15.         if (obj and dis.has_key(oid)==False):
  16.             dis.Add(oid,obj)
  17.         Bool = geo_curve.ClosestPoint(i.Geometry.Location,t)
  18.         if Bool[0]:
  19.             cpt = geo_curve.PointAt(Bool[1])
  20.             i.Move(cpt)
  21. for guid in dis:
  22.     if dis[guid]:
  23.         sc.doc.Objects.GripUpdate(dis[guid],True)

  24. sc.doc.Views.Redraw()
复制代码
关于大陆地区Rhino原厂培训中心
DAKA_Ye 发表于 2017-2-25 17:28:48
12

非常感谢,请教下想改成垂直的投影,不是按法线的投影,该怎么改?
魔龙教主 发表于 2017-2-26 18:35:09
13
筑梦NARUTO 发表于 2017-2-22 21:49
最好用Rhinopython编辑器运行。或者把代码做成按钮运行。
不知道rhinopython的可以先看下jorin大大的视 ...

多谢指教,做成按钮还是提示未知指令,玩不来
魔龙教主 发表于 2017-2-26 18:38:20
14
筑梦NARUTO 发表于 2017-2-22 21:49
最好用Rhinopython编辑器运行。或者把代码做成按钮运行。
不知道rhinopython的可以先看下jorin大大的视 ...

多谢指教,做成按钮还是提示未知指令,玩不来
 楼主| 太平公主主 发表于 2017-2-28 10:13:36
15
本帖最后由 太平公主主 于 2017-2-28 10:16 编辑

发现一个问题,就是如果控制点不在自身的曲面上时,把控制点拉回到另一个曲面上,控制点贴在另一个曲面上了,但原来的面没贴上  ,这是这个小问题,希望大神改进
魔龙教主 发表于 2017-4-1 20:04:27
16
筑梦NARUTO 发表于 2017-2-22 21:49
最好用Rhinopython编辑器运行。或者把代码做成按钮运行。
不知道rhinopython的可以先看下jorin大大的视 ...

哈哈,我会了,谢谢你的代码,很好用
*滑动验证:
您需要登录后才可以回帖 登录 | 注册成为会员

本版积分规则